#include <iostream>
#include "Liste.h"

using namespace std;

template<typename T> class HashTable {
private:
	Liste<T> *table;
protected:
	unsigned int maxBucket;
public:
	HashTable(int aMaxBucket);
	virtual int Hash(T& aElem) = 0;       // rein virtuell!
	bool Contains(T& aElem) { 
		return table[Hash(aElem)].is_elem(aElem); }
	void Delete(T& aElem) { 
		table[Hash(aElem)].remove(aElem); }
	void Insert(T& aElem) { 
		table[Hash(aElem)].append(aElem); }
	void Print();
	~HashTable();
};

template<typename T>
HashTable<T>::HashTable(int aMaxBucket):maxBucket(aMaxBucket) {
	if (maxBucket < 2) throw "invalid bucket size";
	table = new Liste<T>[maxBucket];
}

template<typename T>
HashTable<T>::~HashTable() {
	delete[] table;
}

template<typename T>
void HashTable<T>::Print() {
	for (unsigned int i = 0; i < maxBucket; i++) {
		cout << "\nBucket " << i << " :\n";
		table[i].print();
	}
}
