#include <iostream>
using namespace std;

template<typename T> class Liste {
public:
	Liste();
	Liste(const Liste& liste);
	void append(const T& x);
	void prepend(const T& x);  
	bool empty();
	bool is_elem(const T& x);
	void clear();
	void remove(const T& x);
	void print();
	~Liste();
protected:
	struct Objekt {
		T      data;
		Objekt *next;
	} *sz, *ez;
	void clear(Objekt *obj);
	Objekt *remove(Objekt *obj, const T& x);
	void print(Objekt *obj);
};

template<typename T> Liste<T>::Liste()
: sz(nullptr), ez(nullptr) {
}
template<typename T> Liste<T>::~Liste() {
  clear();
}
template<class T> void Liste<T>::clear() {
  clear(sz);
  sz = ez = nullptr;
}
template<typename T>
void Liste<T>::clear(Objekt *obj) {
  if (obj == nullptr) return;
  clear(obj->next);
  delete obj;
}
template<typename T> void Liste<T>::remove(const T& x){
  sz = remove(sz, x); if (sz == nullptr) ez = nullptr;
}
template<typename T>
typename Liste<T>::Objekt* Liste<T>::remove(Objekt *obj, const T& x) {
  if (obj == nullptr) return nullptr; // oder: Ausnahme!
  if (obj->data == x) {
    Objekt *tmp = obj->next;          // Zeiger retten
    delete obj;                       // Objekt löschen
    return tmp;                       // Zeiger retour
  }
  obj->next = remove(obj->next, x);   // Rekursion
  if (obj->next == nullptr) ez = obj;
  return obj;
}
template<typename T> void Liste<T>::print() {
  print(sz);
}
template<typename T>
void Liste<T>::print(Objekt *obj) {
  static int cnt = 1;   // counter
  if (obj != nullptr) {
    cout << obj->data;
    cout << (cnt++ % 6 ? "\t" : "\n");
    print(obj->next);
  }
  else {
    cnt = 1;
    cout << "(end of list)" << endl;
  }
}
template<typename T>
bool Liste<T>::is_elem(const T& x) {
	Objekt *ptr = sz;
	while (ptr != nullptr) {
		if (ptr->data == x) return true;
		ptr = ptr->next;
	}
	return false;
}
template<typename T>
void Liste<T>::append(const T& x) {
	Objekt *obj = new Objekt;
	obj->data = x;
	obj->next = nullptr;
	if (empty()) sz = obj;
	else ez->next = obj;
	ez = obj;
}
template<typename T>
void Liste<T>::prepend(const T& x){
	Objekt *obj = new Objekt;
	obj->data = x;
	obj->next = sz;
	sz = obj;
	if (empty()) ez = obj;
}
template<typename T>
bool Liste<T>::empty() {
	return (ez == nullptr);
}
