#include <iostream>
#include <random>
#include <chrono>
using namespace std;
template <class T> void Swap(T& a, T& b) {
	T c = b; b = a; a = c;
}
template <class T> void Merge(int const size, T a[], T b[]) {
  T* c = new T[2*size];
  // mischen
  int i = 0, j = 0;
  for (int k = 0; k < 2 * size; k++) {
    if ((j == size) || (i < size && a[i] < b[j]))
      c[k] = a[i++];
    else
      c[k] = b[j++];
  }
  // umkopieren
  for (int k = 0; k < size; k++) {
    a[k] = c[k];
    b[k] = c[k+size];
  }
  delete[] c;
}
template <class T> void Msort(int const size, T a[]) {
  if (size == 2) {	// sortieren
    if (a[0] > a[1]) Swap<T>(a[0], a[1]);
    return;
  }
  // teilen
  int k = size / 2;
  Msort<T>(k, &a[0]);
  Msort<T>(k, &a[k]);
  // mischen
  Merge<T>(k, &a[0], &a[k]);
}
template <class T> void Print(int const size, T a[]) {
	for (int i = 0; i < size; i++) {
		cout << a[i] << "\t";
		if ((i+1) % 8 == 0) cout << endl;
	}
	cout << endl;
}

int main() {
	default_random_engine gen(
		chrono::system_clock::now().time_since_epoch().count());
	uniform_real_distribution<float> distri(1.0,1000.0);
	int const size = 32;
	float a[size];

	for (int k = 0; k < size; k++) a[k] = distri(gen);

	Print<float>(size, a);
	Msort<float>(size, a);
	Print<float>(size, a);
}
